#!/usr/bin/env groovy

@Library('utils') _
import groovy.json.JsonSlurper


pipeline {
    agent any
    environment {
        HOME = '.'
        imageName = "tcosmos/TeamAPT Automation:latest"
        dockerImage = ''
        registryCredential = '2eb91042-a4f4-49bb-ade6-71045b8adc51'
        kubeName = 'TeamAPT Automation'
        dockerRegistry = 'registry.gitlab.com'
        branchName = "${GIT_BRANCH.split("/")[1]}"
        KUBE_CREDENTIALS = """{
	        "main": {
	            "credentialsId": "e5f3a119-9102-44e9-910d-04a57a62aee3",
	            "serverUrl": "https://f859dd90-5526-4f3b-b4cf-0fdae011fc40.k8s.ondigitalocean.com",
	            "clusterName": "do-lon1-development-env",
	            "namespace": "test-automation"
	        },
	        "testing": {
	            "credentialsId": "60f72bf6-2bea-465e-a358-0c598338df6",
	            "serverUrl": "https://f859dd90-5526-4f3b-b4cf-0fdae011fc40.k8s.ondigitalocean.co",
	            "clusterName": "do-lon1-development-en",
	            "namespace": "test-automation"
	        },
	        "uat": {
	            "credentialsId": "60f72bf6-2bea-465e-a358-0c598338df",
	            "serverUrl": "https://f859dd90-5526-4f3b-b4cf-0fdae011fc40.k8s.ondigitalocean.c",
	            "clusterName": "do-lon1-development-e",
	            "namespace": "test-automation"
	        },
	        "production": {
	            "credentialsId": "60f72bf6-2bea-465e-a358-0c598338d",
	            "serverUrl": "https://f859dd90-5526-4f3b-b4cf-0fdae011fc40.k8s.ondigitalocean.",
	            "clusterName": "do-lon1-development-",
	            "namespace": "test-automation"
	        }                
	    }"""

    }
    stages {
        stage('Build and push docker image to registry') {
            when {
                expression {
                    branchName ==~ /^(|main|testing|uat|production)$/  && env.gitlabActionType == 'PUSH'
                }
            }
            steps {
                script {
                    docker.withRegistry('http://registry.gitlab.com', registryCredential) {
                        dockerImage = docker.build "$imageName"
                        dockerImage.push()
                        sh "docker rmi $imageName || true"
                    }
                }
            }
        }
        stage('Cypress Test Automation Stage') {
            when {
	            expression {
	                branchName ==~ /^(|main|testing|uat|production)$/  && env.gitlabActionType == 'PUSH'
	            }
            }
             steps {
               script {
                def kubeCredentials=new JsonSlurper().parseText(KUBE_CREDENTIALS)
                withKubeConfig(kubeCredentials[branchName]) {
                    sh """      
                    kubectl apply -f kubernetes/templates/ -n test-automation
                    """
                }
               }
            }
        
        }
         

    }

    post {
        success {
            echo 'Pipeline successfully completed!'
            script {
                updateGitlabCommitStatus(name: 'jenkins-build', state: 'success')
            }
        }
        failure {
            echo 'Pipeline failed to complete!'
            script {
                updateGitlabCommitStatus(name: 'jenkins-build', state: 'failed')
            }
        }
    }
}
